Codeforces Round 925 (Div. 3) - A、B、C、D、E

2024-02-15 14:12
文章标签 codeforces round div 925

本文主要是介绍Codeforces Round 925 (Div. 3) - A、B、C、D、E,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

文章目录

  • 前言
  • A. Recovering a Small String
  • B. Make Equal
  • C. Make Equal Again
  • D. Divisible Pairs
  • E. Anna and the Valentine's Day Gift

前言

本篇博客是Codeforces Round 925周赛的A、B、C、D、E五题的题解

A. Recovering a Small String

可以通过sum的大小分为三种情况,分别是:(1)aa? (2)a?z (3)?zz,这种方法时间复杂度要比三循环做法低很多

#include<bits/stdc++.h>using namespace std;void solve()
{int sum;cin >> sum;if(3 <= sum && sum <= 28){cout << 'a' << 'a';char r = 'a' - 1 + sum - 2;cout << r << endl;}else if(29 <= sum && sum <= 53){cout << 'a';char r = 'a' - 1 + sum - 27;cout << r;cout << 'z' << endl;}else if(54 <= sum && sum <= 78){char r = 'a' - 1 + sum - 52;cout << r << 'z' << 'z' << endl;}
}int main()
{ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);int T;cin >> T;while (T--) solve();return 0;
}

B. Make Equal

直接用前缀判断即可,从头开始枚举前缀看是否能满足每个范围的水量

#include<bits/stdc++.h>using namespace std;const int N = 2e5 + 20;
int a[N];void solve()
{int n;cin >> n;int sum = 0;for(int i = 1; i <= n; i ++ ){cin >> a[i];sum += a[i];}int temp = sum / n;bool flag = true;int s = 0;for(int i = 1; i <= n; i ++ ){s += a[i];if(s < temp * i){flag = false;break;}}if(flag) cout << "YES" << endl;else cout << "NO" << endl;
}int main()
{ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);int T;cin >> T;while (T--) solve();return 0;
}

C. Make Equal Again

枚举得到第一个与a1不同的位置,最后一个与an不同的位置,a1==an则取r - l + 1,否则取min(n + 1 - l, r)

#include<bits/stdc++.h>using namespace std;const int N  = 2e5 + 10;int a[N];void solve()
{int n;cin >> n;for(int i = 1; i <= n; i ++ ) cin >> a[i];int l = 1, r = n;while(l <= n && a[l] == a[1]) l ++;while(r >= 1 && a[r] == a[n]) r --;if(!r) cout << 0 << endl;else if(a[1] != a[n]) cout << min(n + 1 - l, r) << endl;else cout << r - l + 1 << endl;
}int main()
{ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);int T;cin >> T;while (T--) solve();return 0;
}

D. Divisible Pairs

将所有{ai mod x, ai mod y}存入map,通过余数判断是否存在ai对应的aj,aj则是{(x - (a[i] % x)) % x, a[i] % y}对应的数,这样ai+aj恰好被x整除(余数相加被x整除),ai-aj恰好被y整除(余数恰好消掉)。但是在每次取ai后要使得mp[{a[i] % x, a[i] % y}] --,因为i严格小于j

#include<bits/stdc++.h>
#define pii pair<int, int>
#define ll long longusing namespace std;const int N  = 2e5 + 10;int a[N];void solve()
{int n, x, y;cin >> n >> x >> y;map<pii, int> mp;for(int i = 1;i <= n; i ++ ){cin >> a[i];mp[{a[i] % x, a[i] % y}] ++;}ll ans = 0;for(int i = 1; i <= n; i ++ ){mp[{a[i] % x, a[i] % y}] --; //i严格小于jans += mp[{(x - (a[i] % x)) % x, a[i] % y}];}cout << ans << endl;
}int main()
{ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);int T;cin >> T;while (T--) solve();return 0;
}

E. Anna and the Valentine’s Day Gift

结果取决于最终数的长度,Anna要使长度尽可能小,翻转有后导0的数长度变小;Sasha要使长度尽可能大,将有后导0的数拼接在前可保住长度。所以从Anna每次让后导0最多的元素反转,Sasha每次让后导0最多的拼接在某个数前面,可以使用pair<后导0,总长>来存两者关系

#include<bits/stdc++.h>
#define pii pair<int, int>
#define ll long longusing namespace std;const int N  = 2e5 + 10;pii p[N]; //<后导0,总长>void solve()
{int n, m;cin >> n >> m;for(int i = 1; i <= n; i ++ ){string s;cin >> s;p[i] = {0, s.size()};while(s.back() == '0'){s.pop_back();p[i].first ++;}}sort(p + 1, p + 1 + n, greater<pii>()); //从大到小ll len = 0;for(int i = 1; i <= n; i ++ ){if(i % 2) len += p[i].second - p[i].first; //Sasha操作else len += p[i].second; //Anna操作}if(len > m) cout << "Sasha" <<endl;else cout << "Anna" << endl;
}int main()
{ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);int T;cin >> T;while (T--) solve();return 0;
}

这篇关于Codeforces Round 925 (Div. 3) - A、B、C、D、E的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/711609

相关文章

Codeforces Round #240 (Div. 2) E分治算法探究1

Codeforces Round #240 (Div. 2) E  http://codeforces.com/contest/415/problem/E 2^n个数,每次操作将其分成2^q份,对于每一份内部的数进行翻转(逆序),每次操作完后输出操作后新序列的逆序对数。 图一:  划分子问题。 图二: 分而治之,=>  合并 。 图三: 回溯:

Codeforces Round #261 (Div. 2)小记

A  XX注意最后输出满足条件,我也不知道为什么写的这么长。 #define X first#define Y secondvector<pair<int , int> > a ;int can(pair<int , int> c){return -1000 <= c.X && c.X <= 1000&& -1000 <= c.Y && c.Y <= 1000 ;}int m

Codeforces Beta Round #47 C凸包 (最终写法)

题意慢慢看。 typedef long long LL ;int cmp(double x){if(fabs(x) < 1e-8) return 0 ;return x > 0 ? 1 : -1 ;}struct point{double x , y ;point(){}point(double _x , double _y):x(_x) , y(_y){}point op

Codeforces Round #113 (Div. 2) B 判断多边形是否在凸包内

题目点击打开链接 凸多边形A, 多边形B, 判断B是否严格在A内。  注意AB有重点 。  将A,B上的点合在一起求凸包,如果凸包上的点是B的某个点,则B肯定不在A内。 或者说B上的某点在凸包的边上则也说明B不严格在A里面。 这个处理有个巧妙的方法,只需在求凸包的时候, <=  改成< 也就是说凸包一条边上的所有点都重复点都记录在凸包里面了。 另外不能去重点。 int

Codeforces 482B 线段树

求是否存在这样的n个数; m次操作,每次操作就是三个数 l ,r,val          a[l] & a[l+1] &......&a[r] = val 就是区间l---r上的与的值为val 。 也就是意味着区间[L , R] 每个数要执行 | val 操作  最后判断  a[l] & a[l+1] &......&a[r] 是否= val import ja

CSS实现DIV三角形

本文内容收集来自网络 #triangle-up {width: 0;height: 0;border-left: 50px solid transparent;border-right: 50px solid transparent;border-bottom: 100px solid red;} #triangle-down {width: 0;height: 0;bor

创建一个大的DIV,里面的包含两个DIV是可以自由移动

创建一个大的DIV,里面的包含两个DIV是可以自由移动 <body>         <div style="position: relative; background:#DDF8CF;line-height: 50px"> <div style="text-align: center; width: 100%;padding-top: 0px;"><h3>定&nbsp;位&nbsp;

Codeforces Round 971 (Div. 4) (A~G1)

A、B题太简单,不做解释 C 对于 x y 两个方向,每一个方向至少需要 x / k 向上取整的步数,取最大值。 由于 x 方向先移动,假如 x 方向需要的步数多于 y 方向的步数,那么最后 y 方向的那一步就不需要了,答案减 1 代码 #include <iostream>#include <algorithm>#include <vector>#include <string>

CF#271 (Div. 2) D.(dp)

D. Flowers time limit per test 1.5 seconds memory limit per test 256 megabytes input standard input output standard output 题目链接: http://codeforces.com/contest/474/problem/D We s

CF #278 (Div. 2) B.(暴力枚举+推导公式+数学构造)

B. Candy Boxes time limit per test 1 second memory limit per test 256 megabytes input standard input output standard output 题目链接: http://codeforces.com/contest/488/problem/B There